<?php

// Snort Database Settings

$dbhost = "localhost";
$dbuser = "root";
$dbpass = "";
$dbname = "snort";

// liveSnort Settings

$maxRows = 15;
$pollTime = 5;

#
# No Need to modify and / or edit anything below (unless, of course you would like to)
#

/** Copyright 2003-2008 Remote Assessment
 *
 * liveSnort
 *
 * This program is owned and licensed by Remote Assessment; it may be
 * redistributed only in its original configuration as originally
 * installed and available by Remote Assessment and / or Aanval.
 *
 * To license and / or include this product in other forms or
 * applications, express prior written authorization must be
 * obtained by contract from authorized Remote Assessment or Aanval agents.
 *
 * Remote Assessment and Aanval may not be held liable nor responsible
 * for any and all issues arising from the use of, damages caused by, or
 * conclusions drawn from the use of this product.
 *
 */

// Version Definition
$major = 1;
$minor = 0;
$build = 101;

// Variable Initialization

$op = sanitize("op"); if (empty($op)) $op = "alpha";

// OP Director

switch ($op) {

	case "alpha":

		$out = mainDisplay();
	
		break;

	case "papa":

		$data = doEventQuery();
		pollParse($data);
		exit;

	case "zulu":

		$data = doSnortQuery();
		pollParse($data);
		exit;
	
		break;
		
	default:
	
		break;
}

echo mainHeading() . $out . mainFooting();

// Operational Functions

function mainDisplay() {
	global $major, $minor, $build, $pollTime, $dbname;

	$pollTime = $pollTime * 1000;

	$out .= "<div class=titleDisplay><table border=0 width=100% cellpadding=0 cellspacing=0><tr><td width=175><font color=#FFFFFF>liveSnort Monitor</font></td><td align=center>database: $dbname</td><td width=175 align=right>[ <a href=\"?\">manual reload</a> ]</td></tr></table></div>";

	$out .= "<table border=0 width=100% cellpadding=0 cellspacing=0><tr>";
	$out .= "<td valign=top>";

		$out .= "<div id=object1><SCRIPT LANGUAGE=\"JavaScript\">pollSystem($pollTime,\"object1\",\"zulu\");</script><font color=\"#121212\" size=2>One moment, Loading...</font></div>";

	$out .= "</td><td width=5>&nbsp;</td><td width=250 valign=top>";
	
		$out .= "<div class=eventDisplay id=object2>Click an event to view details</div>";
	
		$out .= "<div style=\"color: #232323; font-size: 10px; margin: 5px;\"><a target=_blank href=\"http://www.aanval.com/liveSnort/\">http://www.aanval.com/liveSnort/</a><p>Aanval by Remote Assessment<br>Copyright &copy; 2003-2008 - All Rights Reserved<p>AJAX/Polling: $pollTime ms<p>Version $major.$minor.$build</div>";
		
	$out .= "</td>";
	$out .= "</tr></table>";

	return $out;
}

function mainHeading() {
	
	$out .= "<html><head><title>liveSnort by Aanval, a Remote Assessment Product</title>";
	
	$out .= "
	
		<style type=\"text/css\">
		
		body {
			background-color: #ABABAB;
		}

		a {
			color: #000000;
		}

		.titleDisplay table {
			background: #fff url(./blackGradient.png) repeat-x;
			border: 1px solid #454545;
			padding: 2px; 
			margin: 3px;
			height: 15px;
			font-size: 13px;
		} 

		.eventBox {
			background: #fff url(./blackGradient.png) repeat-x;
			border: 1px solid #454545;
			padding: 2px; 
			margin: 3px;
			height: 40px;
		} 
		
		.eventBox table {
			font-size: 12px;
		}

		.eventDisplay {
			background: #CDCDCD;
			border: 1px solid #454545;
			padding: 2px; 
			margin: 3px;
			font-size: 12px;
		}

		.eventDisplay table {
			font-size: 12px;
		}

		</style>
	";
	
	$out .= "<script LANGUAGE=\"JavaScript\">";
	
	$out .= "
	
		function opacity(id, opacStart, opacEnd, millisec) { 
		    // Speed for each frame 
		    var speed = Math.round(millisec / 85); 
		    var timer = 0; 
		
		    /*if(opacStart > opacEnd) { 
		        for(i = opacStart; i >= opacEnd; i--) { 
		            setTimeout(\"changeOpac(\" + i + \",'\" + id + \"')\",(timer * speed)); 
		            timer++; 
		        } 
		    } else*/ if(opacStart < opacEnd) { 
		        for(i = opacStart; i <= opacEnd; i++) 
		            {
					
		            setTimeout(\"changeOpac(\" + i + \",'\" + id + \"')\",(timer * speed)); 
		            timer++;
					
		        } 
		    } 
		} 
		
		function changeOpac(opacity, id) { 
		    var object = document.getElementById(id).style; 
		    object.opacity = (opacity / 100); 
		    object.MozOpacity = (opacity / 100); 
		    object.KhtmlOpacity = (opacity / 100); 
		    object.filter = \"alpha(opacity=\" + opacity + \")\";
		}
		
	    function pollConnector(s) {
			var timer;

			var head = document.getElementsByTagName('head').item(0);
			var old  = document.getElementById('scriptId');
			if (old) head.removeChild(old);

			script = document.createElement('script');
			var now = new Date();
			script.src = s+now.valueOf();
			script.type = 'text/javascript';
			script.defer = true;
			script.id = 'scriptId';

			void(head.appendChild(script));
			head = null;
			old = null;
			script = null;
			CollectGarbage();
	    }
	
		function pollSystem(t,p,f) { timer_poll = setInterval('pollConnector(\"?op='+f+'&obj='+p+'&epoch=\")', t); }
	    
	";
	
	$out .= "</script>";
	
	$out .= "</head><body>";
	
	return $out;
}

function mainFooting() {

	$out = "</body></html>";
	
	return $out;
}

// Snort Functions

function doEventQuery() {

	$id = sanitize("id");
	$s = sanitize("s");

	$siteDB = new siteDB();

	$query1 = "select event.sid, event.cid, event.signature, UNIX_TIMESTAMP(event.timestamp) as timestamp, iphdr.ip_src, iphdr.ip_dst, iphdr.ip_proto, signature.sig_name, signature.sig_sid, signature.sig_class_id, signature.sig_priority, sig_class.sig_class_name from event, iphdr, signature, sig_class where (event.cid = iphdr.cid) and (event.sid = iphdr.sid) and (event.signature = signature.sig_id) and (signature.sig_class_id = sig_class.sig_class_id) and event.sid = '$s' and event.cid = '$id'";

	$siteQ = $siteDB->query($query1);
	for ($i = 0; $row = mysql_fetch_row($siteQ); $i++) {

		for ($p = 0; $p < count($row); $p++) {
			$array[mysql_field_name($siteQ, $p)] = $row[$p];
		}

		if ($array["ip_proto"] == 6) {
		
			$array["ip_protoName"] = "TCP";
		
			$siteQ2 = $siteDB->query("select tcphdr.tcp_sport as sport, tcphdr.tcp_dport as dport, tcphdr.tcp_seq as seq, tcphdr.tcp_ack as ack, tcphdr.tcp_off as off, tcphdr.tcp_res as res, tcphdr.tcp_flags as flags, tcphdr.tcp_win as win, tcphdr.tcp_csum as csum, tcphdr.tcp_urp as urp from tcphdr where tcphdr.cid = " . $array["cid"] . " and tcphdr.sid = " . $array["sid"]);
			for ($t = 0; $row2 = mysql_fetch_row($siteQ2); $t++) {

				for ($p = 0; $p < count($row2); $p++) {
					$array[mysql_field_name($siteQ2, $p)] = $row2[$p];
				}

			}
		} else if ($array["ip_proto"] == 17) {

			$array["ip_protoName"] = "UDP";
			
			$siteQ2 = $siteDB->query("select udphdr.udp_sport as sport, udphdr.udp_dport as dport, udphdr.udp_len as len, udphdr.udp_csum as csum from udphdr where udphdr.cid = " . $array["cid"] . " and udphdr.sid = " . $array["sid"]);
			for ($t = 0; $row2 = mysql_fetch_row($siteQ2); $t++) {

				for ($p = 0; $p < count($row2); $p++) {
					$array[mysql_field_name($siteQ2, $p)] = $row2[$p];
				}

			}		
		} else if ($array["ip_proto"] == 1) {

			$array["ip_protoName"] = "ICMP";
			
			$siteQ2 = $siteDB->query("select icmphdr.icmp_type as type, icmphdr.icmp_code as code, icmphdr.icmp_csum as csum, icmphdr.icmp_seq as seq, icmphdr.icmp_id as icmpid from icmphdr where icmphdr.cid = " . $array["cid"] . " and icmphdr.sid = " . $array["sid"]);
			for ($t = 0; $row2 = mysql_fetch_row($siteQ2); $t++) {

				for ($p = 0; $p < count($row2); $p++) {
					$array[mysql_field_name($siteQ2, $p)] = $row2[$p];
				}

			}		
		}

	}

	$siteDB->close();

	$out .= "<table border=0 cellpadding=0 cellspacing=0 width=100%>";

	$out .= "<tr><td width=75>Event</td><td>" . $array["cid"] . "</td></tr>";
	$out .= "<tr><td>Sensor</td><td>" . $array["sid"] . "</td></tr>";
	$out .= "</table>";

	$out .= "<br>";

	$out .= "<table border=0 cellpadding=0 cellspacing=0 width=100%>";
	$out .= "<tr><td>" . date("r", $array["timestamp"]) . "</td></tr>";
	$out .= "<tr><td>&nbsp;</td></tr>";
	$out .= "<tr><td>" . $array["sig_name"] . "</td></tr>";
	$out .= "<tr><td>" . $array["sig_class_name"] . "</td></tr>";
	$out .= "</table>";

	$out .= "<br>";

	$out .= "<table border=0 cellpadding=0 cellspacing=0 width=100%>";

	$out .= "<tr><td width=75>Signature</td><td>" . $array["sig_sid"] . " | <a target=_blank href=\"http://www.snort.org/pub-bin/sigs.cgi?sid=" . $array["sig_sid"] . "\">Details</a></td></tr>";
	$out .= "<tr><td>Class</td><td>" . $array["sig_class_id"] . "</td></tr>";

	$out .= "<tr><td>&nbsp;</td><td>&nbsp;</td></tr>";
	
	$out .= "<tr><td>Priority</td><td>" . $array["sig_priority"] . "</td></tr>";

	$out .= "<tr><td>&nbsp;</td><td>&nbsp;</td></tr>";

	$out .= "<tr><td>Source</td><td>" . longToIP($array["ip_src"]);
		if ($array["sport"]) {
			$out .= " : " . $array["sport"];
		}
	$out .= "</td></tr>";

	$out .= "<tr><td>Destination</td><td>" . longToIP($array["ip_dst"]);
		if ($array["dport"]) {
			$out .= " : " . $array["dport"];
		}
	$out .= "</td></tr>";

	$out .= "<tr><td>&nbsp;</td><td>&nbsp;</td></tr>";

	$out .= "<tr><td>Protocol</td><td>" . $array["ip_protoName"] . " [" . $array["ip_proto"] . "]" . "</td></tr>";

	if ($array["csum"]) $out .= "<tr><td>CSum</td><td>" . $array["csum"] . "</td></tr>";
	if ($array["seq"]) $out .= "<tr><td>Seq</td><td>" . $array["seq"] . "</td></tr>";
	if ($array["ack"]) $out .= "<tr><td>Ack</td><td>" . $array["ack"] . "</td></tr>";
	if ($array["off"]) $out .= "<tr><td>Off</td><td>" . $array["off"] . "</td></tr>";
	if ($array["res"]) $out .= "<tr><td>Res</td><td>" . $array["res"] . "</td></tr>";
	if ($array["win"]) $out .= "<tr><td>Win</td><td>" . $array["win"] . "</td></tr>";
	if ($array["urp"]) $out .= "<tr><td>URP</td><td>" . $array["urp"] . "</td></tr>";
	if ($array["len"]) $out .= "<tr><td>Len</td><td>" . $array["len"] . "</td></tr>";

	if ($array["type"]) $out .= "<tr><td>Type</td><td>" . $array["type"] . "</td></tr>";
	if ($array["code"]) $out .= "<tr><td>Code</td><td>" . $array["code"] . "</td></tr>";
	if ($array["icmpid"]) $out .= "<tr><td>ICMP ID</td><td>" . $array["icmpid"] . "</td></tr>";

	$out .= "<tr><td>&nbsp;</td><td>&nbsp;</td></tr>";

	$out .= "</table>";

	return $out;
}

function doSnortQuery() {
	global $maxRows;
	
	$siteDB = new siteDB();
	
	$orderBy = "event.timestamp";
	
	$query1 = "select event.sid, event.cid, event.signature, UNIX_TIMESTAMP(event.timestamp) as timestamp, iphdr.ip_src, iphdr.ip_dst, iphdr.ip_proto, signature.sig_name, signature.sig_priority, sig_class.sig_class_name from event, iphdr, signature, sig_class where (event.cid = iphdr.cid) and (event.sid = iphdr.sid) and (event.signature = signature.sig_id) and (signature.sig_class_id = sig_class.sig_class_id) order by $orderBy desc limit $maxRows";

	$siteQ = $siteDB->query($query1);
	for ($i = 0; $row = mysql_fetch_row($siteQ); $i++) {

		for ($p = 0; $p < count($row); $p++) {
			$array[mysql_field_name($siteQ, $p)] = $row[$p];
		}

		if ($array["ip_proto"] == 6) {
		
			$array["ip_protoName"] = "TCP";
		
			$siteQ2 = $siteDB->query("select tcphdr.tcp_sport as sport, tcphdr.tcp_dport as dport, tcphdr.tcp_seq as seq, tcphdr.tcp_ack as ack, tcphdr.tcp_off as off, tcphdr.tcp_res as res, tcphdr.tcp_flags as flags, tcphdr.tcp_win as win, tcphdr.tcp_csum as csum, tcphdr.tcp_urp as urp from tcphdr where tcphdr.cid = " . $array["cid"] . " and tcphdr.sid = " . $array["sid"]);
			for ($t = 0; $row2 = mysql_fetch_row($siteQ2); $t++) {

				for ($p = 0; $p < count($row2); $p++) {
					$array[mysql_field_name($siteQ2, $p)] = $row2[$p];
				}

			}
		} else if ($array["ip_proto"] == 17) {

			$array["ip_protoName"] = "UDP";
			
			$siteQ2 = $siteDB->query("select udphdr.udp_sport as sport, udphdr.udp_dport as dport, udphdr.udp_len as len, udphdr.udp_csum as csum from udphdr where udphdr.cid = " . $array["cid"] . " and udphdr.sid = " . $array["sid"]);
			for ($t = 0; $row2 = mysql_fetch_row($siteQ2); $t++) {

				for ($p = 0; $p < count($row2); $p++) {
					$array[mysql_field_name($siteQ2, $p)] = $row2[$p];
				}

			}		
		} else if ($array["ip_proto"] == 1) {

			$array["ip_protoName"] = "ICMP";
			
			$siteQ2 = $siteDB->query("select icmphdr.icmp_type as type, icmphdr.icmp_code as code, icmphdr.icmp_csum as csum, icmphdr.icmp_seq as seq, icmphdr.icmp_id as icmpid from icmphdr where icmphdr.cid = " . $array["cid"] . " and icmphdr.sid = " . $array["sid"]);
			for ($t = 0; $row2 = mysql_fetch_row($siteQ2); $t++) {

				for ($p = 0; $p < count($row2); $p++) {
					$array[mysql_field_name($siteQ2, $p)] = $row2[$p];
				}

			}		
			
		}

		$out .= "<div class=eventBox>" . eventRowFormat($array) . "</div>";

		unset($array);
	}
	
	$siteDB->close();	
	
	return $out;
}

function eventRowFormat($data) {

	$out .= "<table border=0 width=100% cellpadding=0 cellspacing=0><tr onmouseover=\"this.style.cursor=&#39;hand&#39;\" onmouseup=\"javascript:opacity(&#39;object2&#39;, 0, 100, 1000);\" onClick=\"javascript:pollConnector(&#39;?op=papa&obj=object2&id=" . $data["cid"] . "&s=" . $data["sid"] . "&epoch=&#39;);\">";
	$out .= "<td width=50 valign=middle align=center>";

		$out .= "<div style=\"font-size: 20px;\">" . $data["sig_priority"] . "</div>";
		$out .= "<div style=\"font-size: 12px; text-align: center;\">Priority</div>";

	$out .= "</td><td width=10 valign=top>";

		$out .= "&nbsp;";

	$out .= "</td><td width=130 valign=top>";

		$out .= "<div style=\"color: #DEDEDE\">";

		if ($data["sport"]) {
			$out .= longToIP($data["ip_src"]) . " : " . $data["sport"];
		} else {
			$out .= longToIP($data["ip_src"]);
		}
		
		$out .= "</div>";

	$out .= "</td><td width=130 valign=top>";

		$out .= "<div style=\"color: #DEDEDE\">";

		if ($data["dport"]) {
			$out .= longToIP($data["ip_dst"]) . " : " . $data["dport"];
		} else {
			$out .= longToIP($data["ip_dst"]);
		}
	
		$out .= "</div>";

		$out .= "<div style=\"padding-top: 1px; font-size: 11px;\">" . $data["ip_protoName"] . " <font color=#121212>[" . $data["ip_proto"] . "]<font>" . "</div>";
	
	$out .= "</td><td valign=top>";

		$out .= "<font color=#DEDEDE>" . $data["sig_name"] . "</font>";
		$out .= "<br>";
		$out .= "<font color=#121212>" . $data["sig_class_name"] . "</font>";

	$out .= "</td><td valign=top align=right>";

		$out .= "<font color=#DEDEDE>" . date("r", $data["timestamp"]) . "</font>";
		$out .= "<br>";
		
		$out .= "<font color=#121212>" . eventTimeDiffDisplay($data["timestamp"]) . "</font>";

	$out .= "</td>";
	$out .= "</tr></table>";

	return $out;
	
}

// Support Functions

function pollParse($data) {

	$obj = getVar("obj");

	header ("Content-type: text/javascript");

    echo "document.getElementById('$obj').innerHTML='$data';";

    unset($data, $obj);
}

function sanitize($in) {

	return strip_tags(addslashes(getVar($in)));

}

function getVar($in) {

    if (isset($_POST[$in])) {
        $out = $_POST[$in];
    } else {
        $out = $_GET[$in];
    }
    
	if (get_magic_quotes_gpc()) {
        if (is_array($out)) {
            foreach ($out as $el) {
				$array[] = stripslashes($el);
            }
            $out = $array;
        } else {
	        $out = stripslashes($out);
        }    
	}
        
    return $out;
}

function longToIP($in) {
	
	$tmp = $in;
	
	if ($in > 2147483647) {
		$tmp = 4294967296 - $in;
		$tmp = $tmp * (-1);
	}
	
	$tmp = long2ip($tmp);
	
	return $tmp;
}

class siteDB {
    function siteDB() {
        global $dbhost, $dbuser, $dbpass, $dbname;

        $this->host = $dbhost;
        $this->db = $dbname;
        $this->user = $dbuser;
        $this->pass = $dbpass;

		$this->link = mysql_connect($this->host, $this->user, $this->pass, 1);
		
        mysql_select_db($this->db);
    }

    function query($query) {
    	
        if ($result = @mysql_query($query, $this->link)) {
        	return $result;
        }
    }

    function close() {
    	
        @mysql_close($this->link);
    }
}

function eventTimeDiffDisplay($intime) {

	if ($intime) {

		$diff = date("U") - $intime;

		while ($diff != 0) {

			if ($diff >= 31536000) {
				$array["year"]++;
				$diff -= 31536000;
			} else if ($diff >= 2592000) {
				$array["month"]++;
				$diff -= 2592000;
			} else if ($diff >= 86400) {
				$array["day"]++;
				$diff -= 86400;
			} else if ($diff >= 3600) {
				$array["hour"]++;
				$diff -= 3600;
			} else if ($diff >= 60) {
				$array["minute"]++;
				$diff -= 60;
			} else {
				$array["second"] += $diff;
				$diff -= $diff;
			}

		}

	}

	if ($array) {

		$color = "#121212";

		if ($array["year"]) {
			$out .= " " . $array["year"] . " Year";
			if ($array["year"] > 1) $out .= "s";
			$out .= ",";
		}

		if ($array["month"]) {
			$out .= " " . $array["month"] . " Month";
			if ($array["month"] > 1) $out .= "s";
			$out .= ",";
		}

		if ($array["day"]) {
			$out .= " " . $array["day"] . " Day";
			if ($array["day"] > 1) $out .= "s";
			$out .= ",";
		}

		if ($array["hour"]) {
			$out .= " " . $array["hour"] . " Hour";
			if ($array["hour"] > 1) $out .= "s";
			$out .= ",";
		}

		if ($array["minute"]) {
			$out .= " " . $array["minute"] . " Minute";
			if ($array["minute"] > 1) $out .= "s";
			$out .= ",";
		}

		if ($array["second"]) {
			$out .= " " . $array["second"] . " Second";
			if ($array["second"] > 1) $out .= "s";
			
			if (!$array["minute"]) $color = "#660000";
		}

		$out = trim($out) . " ago";

		$out = "<div style=\"color: $color\">" . $out . "</div>";
	}

	return $out;
}

?>